
.. DO NOT EDIT.
.. THIS FILE WAS AUTOMATICALLY GENERATED BY SPHINX-GALLERY.
.. TO MAKE CHANGES, EDIT THE SOURCE PYTHON FILE:
.. "gallery/hidet-script/0-hello-world.py"
.. LINE NUMBERS ARE GIVEN BELOW.

.. only:: html

    .. note::
        :class: sphx-glr-download-link-note

        :ref:`Go to the end <sphx_glr_download_gallery_hidet-script_0-hello-world.py>`
        to download the full example code

.. rst-class:: sphx-glr-example-title

.. _sphx_glr_gallery_hidet-script_0-hello-world.py:


Hello World!
============

In this example, we will show you how to use hidet to write a simple "Hello World" program.

.. GENERATED FROM PYTHON SOURCE LINES 9-10

Hidet is a deep learning compiler implemented in python. Let's import it first.

.. GENERATED FROM PYTHON SOURCE LINES 10-12

.. code-block:: default

    import hidet








.. GENERATED FROM PYTHON SOURCE LINES 13-15

Hidet caches all its generated source code and binary in its cache directory. We can set the cache directory
to a local directory ``./outs/cache`` so that you can check the generated code and binary.

.. GENERATED FROM PYTHON SOURCE LINES 15-17

.. code-block:: default

    hidet.option.cache_dir('./outs/cache')








.. GENERATED FROM PYTHON SOURCE LINES 18-20

The ``hidet.lang`` submodule implements the Hidet Script domain specific language.
In this example, we will use ``attrs`` variable and ``printf`` function from ``hidet.lang``.

.. GENERATED FROM PYTHON SOURCE LINES 20-22

.. code-block:: default

    from hidet.lang import attrs, printf








.. GENERATED FROM PYTHON SOURCE LINES 23-26

A **script module** is a compilation unit that contains a list of functions defined in it. Inside a script module,
we can use ``hidet.script`` to define a hidet script function. The following example defines a function named
``launch`` that prints a message to the standard output.

.. GENERATED FROM PYTHON SOURCE LINES 26-40

.. code-block:: default


    with hidet.script_module() as script_module:

        # we use `hidet.script` to decorate a python function to define a hidet script function.
        @hidet.script
        def launch():
            # we use `hidet.lang.attrs` to set the attributes of the function.
            # the following line specify this hidet script function is a public function.
            attrs.func_kind = 'public'

            # print a message to the standard output.
            printf("Hello World!\n")









.. GENERATED FROM PYTHON SOURCE LINES 41-43

With the script module defined, we can build the script module with ``build()`` method. The returned ``module`` is
an instance of ``hidet.runtime.CompiledModule``, which contains the compiled binary.

.. GENERATED FROM PYTHON SOURCE LINES 43-45

.. code-block:: default

    module = script_module.build()








.. GENERATED FROM PYTHON SOURCE LINES 46-53

We can directly call the compiled module, in this case the 'launch' function would be invoked.

.. note::
   :class: margin

   The printed message has not been captured by our documentation generation tool (i.e., sphinx).
   If you run the script by yourself, you will see the message printed out in your console.

.. GENERATED FROM PYTHON SOURCE LINES 53-55

.. code-block:: default

    module()








.. GENERATED FROM PYTHON SOURCE LINES 56-57

We can also explicitly specify the function to be invoked using ``module['func_name'](args)``.

.. GENERATED FROM PYTHON SOURCE LINES 57-59

.. code-block:: default

    module['launch']()








.. GENERATED FROM PYTHON SOURCE LINES 60-67

you can access the source code of the compiled module using ``module.source()``.

.. note::
   :class: margin

   The function in the source code has a prefix ``hidet_``, which is used to avoid name conflict with standard
   library functions.

.. GENERATED FROM PYTHON SOURCE LINES 67-68

.. code-block:: default

    print(module.source(color=True))




.. rst-class:: sphx-glr-script-out

 .. code-block:: none

    #include <stdint.h>
    #include <math.h>
    #include <hidet/runtime/symbols.h>
    #include <hidet/runtime/memory_planner.h>
    #include <hidet/runtime/cpu/context.h>
    #include <hidet/runtime/cpu/float32.h>
    #include <hidet/runtime/logging.h>


    DLL void hidet_launch() {
      printf("Hello World!\n");
    }






.. rst-class:: sphx-glr-timing

   **Total running time of the script:** (0 minutes 0.009 seconds)


.. _sphx_glr_download_gallery_hidet-script_0-hello-world.py:

.. only:: html

  .. container:: sphx-glr-footer sphx-glr-footer-example




    .. container:: sphx-glr-download sphx-glr-download-python

      :download:`Download Python source code: 0-hello-world.py <0-hello-world.py>`

    .. container:: sphx-glr-download sphx-glr-download-jupyter

      :download:`Download Jupyter notebook: 0-hello-world.ipynb <0-hello-world.ipynb>`


.. only:: html

 .. rst-class:: sphx-glr-signature

    `Gallery generated by Sphinx-Gallery <https://sphinx-gallery.github.io>`_
